/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#if !defined(AFX_HIDDEVICES_H__91EBA3B7_8961_423F_95F0_25F998DD9F17__INCLUDED_)
#define AFX_HIDDEVICES_H__91EBA3B7_8961_423F_95F0_25F998DD9F17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HIDDevice.h"
#include "utils/HList.h"
#include "utils/HArray.h"
class HIDAcme;
class HIDGraphics;

#define ALL_HID		0
#define CHOOSE_HID	1
#define MY_HID		2

class HIDDevices
{
public:
	HIDDevices();
	virtual ~HIDDevices();

	enum DEV_TYPE
	{
		DEV_TYPE_LCD,
		DEV_TYPE_INSTALL,
		DEV_TYPE_IR
	};

#ifdef _WIN32
	void enumerateUSBDevices();
#endif
	void enumerateHIDDevices();

#ifndef _WIN32
	void setRootPath(const char* path);
#endif
	
	HIDDescriptor* chooseHIDDevice(const char* manufact, const char* prod_lcd, const char* prod_flash, const unsigned short vendor, const unsigned short PID, int devno=-1, int dev_type=0);
	HIDDevice* openDevice(HIDDescriptor* hdesc);
//	HIDAcme* openAcme(HIDDescriptor* hdesc, HIDGraphics* gp);

private:
#ifdef _WIN32
	bool GetDeviceProperty(HDEVINFO IntDevInfo2, GUID* guid, DWORD Index , int search_type , int dev_type=0, HList* path_list = NULL, const char* smanufact = NULL, const char* sprod_lcd=NULL, const char* sprod_flash=NULL, const unsigned short nvendor=-1, const unsigned short nPID=-1);
#else
	bool GetDeviceProperty(int type , HList* path_list = NULL, const char* smanufact = NULL, const char* sproduct = NULL, const unsigned short nvendor=-1, const unsigned short nPID=-1);

	char m_rootPath[1024];
#endif

	bool IsMyDevice(int dev_type, HIDD_ATTRIBUTES& Attributes, HIDP_CAPS& Capabilities);
};

#endif // !defined(AFX_HIDDEVICES_H__91EBA3B7_8961_423F_95F0_25F998DD9F17__INCLUDED_)
