/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */


#include "stdafx.h"
#include "HIDInterface.h"
#include "HIDDevice.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HIDInterface::HIDInterface(HIDDevice* hdev)
{
	m_pParent = hdev;
	if (m_pParent) m_pParent->setParser(this);
}

HIDInterface::~HIDInterface()
{
	if (m_pParent) m_pParent->setParser(NULL);
}

void HIDInterface::OpenDevice()
{
	if (m_pParent) m_pParent->OpenDevice();
}

void HIDInterface::CloseDevice()
{
	if (m_pParent) m_pParent->CloseDevice();
}

bool HIDInterface::isConnected()
{
	if (m_pParent) return m_pParent->isRunning();
	else return false;
}

void HIDInterface::WriteArray(HArray* array)
{
	if (m_pParent) m_pParent->Write(array);
}