/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#if !defined(AFX_BASECLASSFORCARDS_H__INCLUDED_)
#define AFX_BASECLASSFORCARDS_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BaseClassForCards.h : header file
//

#include "CardLCD.h"
#include "CardFont.h"
#include "CardFlash.h"
#include "CardSplash.h"

/////////////////////////////////////////////////////////////////////////////
// CBaseClassForCards

class CBaseClassForCards : public CPropertySheet
{
	DECLARE_DYNAMIC(CBaseClassForCards)

// Construction
public:
	CBaseClassForCards(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBaseClassForCards)
	public:
	virtual BOOL OnInitDialog();
	virtual BOOL DestroyWindow();
	//}}AFX_VIRTUAL

	virtual ~CBaseClassForCards();
	/**
	* This member indicate which property page is activated  
	*/
	int m_nActivePage;
	bool m_bFlasher;

	void CheckPages(bool flasher);

	CCardLCD*		m_pCardLCD;
	CCardFont*		m_pCardFont;
	CCardFlash*		m_pCardFlash;
	CCardSplash*	m_pCardSplash;

	// Generated message map functions
protected:
	void setCaption(int pos, CString str);

	//{{AFX_MSG(CBaseClassForCards)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

////////// DISABLE TAB STUFF /////////////
protected:
       // we save the current page in TCN_SELCHANGING
       int m_nLastActive;
       // list of indexes of disabled pages
       CMap <int, int&, int, int&> m_DisabledPages;
  public:
       void EnablePage (int nPage, BOOL bEnable = TRUE);

protected:
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASECLASSFORCARDS_H__INCLUDED_)
