/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */


#include "stdafx.h"
#include "PicoLCD4x20.h"
#include "CardFont.h"
#include "PicoLCD4x20Dlg.h"

// CCardFont dialog

IMPLEMENT_DYNAMIC(CCardFont, CPropertyPage)

CCardFont::CCardFont()
	: CPropertyPage(CCardFont::IDD)
{

}

CCardFont::~CCardFont()
{
	DestroyWindow();
}

void CCardFont::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_CHAR, m_listChar);

	DDX_Control(pDX, IDC_CHECK_FONT_0_0, m_cbChar[0][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_0_1, m_cbChar[0][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_0_2, m_cbChar[0][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_0_3, m_cbChar[0][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_0_4, m_cbChar[0][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_1_0, m_cbChar[1][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_1_1, m_cbChar[1][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_1_2, m_cbChar[1][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_1_3, m_cbChar[1][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_1_4, m_cbChar[1][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_2_0, m_cbChar[2][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_2_1, m_cbChar[2][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_2_2, m_cbChar[2][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_2_3, m_cbChar[2][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_2_4, m_cbChar[2][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_3_0, m_cbChar[3][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_3_1, m_cbChar[3][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_3_2, m_cbChar[3][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_3_3, m_cbChar[3][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_3_4, m_cbChar[3][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_4_0, m_cbChar[4][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_4_1, m_cbChar[4][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_4_2, m_cbChar[4][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_4_3, m_cbChar[4][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_4_4, m_cbChar[4][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_5_0, m_cbChar[5][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_5_1, m_cbChar[5][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_5_2, m_cbChar[5][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_5_3, m_cbChar[5][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_5_4, m_cbChar[5][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_6_0, m_cbChar[6][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_6_1, m_cbChar[6][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_6_2, m_cbChar[6][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_6_3, m_cbChar[6][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_6_4, m_cbChar[6][4]);

	DDX_Control(pDX, IDC_CHECK_FONT_7_0, m_cbChar[7][0]);
	DDX_Control(pDX, IDC_CHECK_FONT_7_1, m_cbChar[7][1]);
	DDX_Control(pDX, IDC_CHECK_FONT_7_2, m_cbChar[7][2]);
	DDX_Control(pDX, IDC_CHECK_FONT_7_3, m_cbChar[7][3]);
	DDX_Control(pDX, IDC_CHECK_FONT_7_4, m_cbChar[7][4]);
}


BEGIN_MESSAGE_MAP(CCardFont, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_SEND_CHAR, &CCardFont::OnBnClickedButtonSendChar)
END_MESSAGE_MAP()


// CCardFont message handlers

BOOL CCardFont::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_listChar.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCardFont::OnBnClickedButtonSendChar()
{
	char map[8];

	for (int row=0;row<8;row++)
	{
		map[row] = 0;

		for (int col=0;col<5;col++)
		{
			if (m_cbChar[row][4-col].GetCheck()!=0)
				map[row] |= (1<<col);
		}
	}

#ifdef _LCD_4x20
	((CPicoLCD4x20Dlg*)AfxGetMainWnd())->m_pHIDInterfaceLCD->setFont(m_listChar.GetCurSel(), map);
#endif
}