/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#pragma once
#include "afxwin.h"
#include "afxcmn.h"


// CCardLCD dialog

class CCardLCD : public CPropertyPage
{
	DECLARE_DYNAMIC(CCardLCD)

public:
	CCardLCD();
	virtual ~CCardLCD();

// Dialog Data
	enum { IDD = IDD_CARD_LCD };

	void SendText();

protected:
	CString m_strLCD;
	UINT_PTR m_nTimer;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	void SendInitialValues();
	void SendContrast();
	void SendBacklight();

	void UpdateKeys(int n1, int n2);
	int m_nKeys[2];
	void UpdateIR();

	CEdit m_editText;
	CButton m_cboxLed[8];
	CSliderCtrl m_sliderContrast;
	CSliderCtrl m_sliderBacklight;
	CStatic m_staticKey[8];
	CProgressCtrl m_progressIR;
	
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedCheckLed1();
	afx_msg void OnBnClickedCheckLed2();
	afx_msg void OnBnClickedCheckLed3();
	afx_msg void OnBnClickedCheckLed4();
	afx_msg void OnBnClickedCheckLed5();
	afx_msg void OnBnClickedCheckLed6();
	afx_msg void OnBnClickedCheckLed7();
	afx_msg void OnBnClickedCheckLed8();
	afx_msg void OnNMReleasedcaptureSliderContrast(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMReleasedcaptureSliderBrightness(NMHDR *pNMHDR, LRESULT *pResult);
	virtual BOOL DestroyWindow();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnBnClickedButtonCommands();
};
