/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */


#include "stdafx.h"
#include "PicoLCD4x20.h"
#include "CardSplash.h"


// CCardSplash dialog

IMPLEMENT_DYNAMIC(CCardSplash, CPropertyPage)

CCardSplash::CCardSplash()
	: CPropertyPage(CCardSplash::IDD)
{
	m_pSplashDialog = NULL;
}

CCardSplash::~CCardSplash()
{
	if (m_pSplashDialog) delete m_pSplashDialog; m_pSplashDialog = NULL;
}

void CCardSplash::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CCardSplash, CPropertyPage)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CCardSplash message handlers

BOOL CCardSplash::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	if (!m_pSplashDialog)
	{
		m_pSplashDialog = new CSplashDialog(this);
		PostMessage(WM_SIZE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCardSplash::OnSize(UINT nType, int cx, int cy)
{
	CPropertyPage::OnSize(nType, cx, cy);

	if (m_pSplashDialog && m_pSplashDialog->GetSafeHwnd())
	{
		CRect rect;
		GetClientRect(&rect);

		m_pSplashDialog->MoveWindow(rect);
	}
}
