/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */


#pragma once

#include "BaseClassForCards.h"
#include "..\HIDPico4x20.h"
#include "..\HIDDevices.h"
#include "..\HIDGraphics.h"

#define TIMEUT 5000
#define WM_DISCONNECTED				WM_USER+100

// CPicoLCD4x20Dlg dialog
class CPicoLCD4x20Dlg : public CDialog, HIDGraphics
{
// Construction
public:
	CPicoLCD4x20Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_PICOLCD4X20_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
public:
	virtual void UpdateStatus(bool fromsocket, int type, int n1, int n2);

	void SwitchMode();
	void Connect(bool mbox);

	HICON				m_hIcon;
	CBaseClassForCards* m_pCards;
	CFont				m_fontMedium;
	CFont				m_fontBig;

	HIDDevices			m_devices;
	HIDDevice*			m_pHIDDevLCD;
	HIDDevice*			m_pHIDDevInstall;
	HIDDevice*			m_pHIDDevIR;
	HIDPico4x20*		m_pHIDInterfaceLCD;
	//HIDPico4x20*		m_pHIDInterfaceInstall;
	HIDPico4x20*		m_pHIDInterfaceIR;

protected:
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	virtual BOOL DestroyWindow();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDisconnected();
};
