/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#include "stdafx.h"
#include "..\HIDPico4x20.h"

void SetComponentSize(CWnd *parent, int ID, int x, int y, int w, int h)
{
	CWnd *cwnd = parent->GetDlgItem(ID);
	if (cwnd!=NULL) cwnd->MoveWindow(x,y,w,h,TRUE);
}

void SetComponentSize(CWnd &cwnd, int x, int y, int w, int h)
{
	cwnd.MoveWindow(x,y,w,h,TRUE);
}

BOOL SetControlParent(CWnd *parent, int ID)
{
	CWnd *c = parent->GetDlgItem(ID);
	if (c != NULL)
	{
		c->ModifyStyleEx (0, WS_EX_CONTROLPARENT);
		return TRUE;
	}
	else return FALSE;
}

int g_nDbg = 0;

void SetDbgLevel(int dbg)
{
	g_nDbg = dbg;
}

int  GetDbgLevel()
{
	return g_nDbg;
}

void MyTrace(int dbg, const char * lpszFormat,...)
{
	if (dbg <= g_nDbg)
	{
		va_list args;
		va_start(args, lpszFormat);
		
		char szBuffer[1024];
		const int nBufferSize = sizeof( szBuffer ) / sizeof( szBuffer [0]);
		int nBuf = _vsnprintf(szBuffer, nBufferSize, lpszFormat, args);
		
		TRACE(szBuffer);

		va_end(args);
	}
}

long getno(const char* no)
{
	if (!no) return 0;
	if (no[0] == 0) return 0;

	if (no[0] == 'x') return strtol(no+1, NULL, 16);
	else return strtol(no, NULL, 10);
}

long getno(const char *s, int base)
{
	return strtol( s, NULL, base );
}

int convertslash(char* buf)
{
	if (!buf) return 0;
	if (buf[0] == 0) return 0;

	int len = strlen(buf);
	char* temp = new char[len+1];

	strcpy(temp, buf);

	int cnt_temp = 0;
	int cnt_buf = 0;

	while (cnt_temp < len)
	{
		if (temp[cnt_temp] != '\\')
		{
			buf[cnt_buf++] = temp[cnt_temp];
			cnt_temp ++;
		}
		else
		{
			switch (temp[cnt_temp+1])
			{
			case '\\':buf[cnt_buf++] = '\\';break;
			case '0':buf[cnt_buf++] = 0;break;
			case '1':buf[cnt_buf++] = 1;break;
			case '2':buf[cnt_buf++] = 2;break;
			case '3':buf[cnt_buf++] = 3;break;
			case '4':buf[cnt_buf++] = 4;break;
			case '5':buf[cnt_buf++] = 5;break;
			case '6':buf[cnt_buf++] = 6;break;
			case '7':buf[cnt_buf++] = 7;break;
			case '8':buf[cnt_buf++] = 8;break;
			case '9':buf[cnt_buf++] = 9;break;
			/*case 'n':buf[cnt_buf++] = '\n';break;
			case 'r':buf[cnt_buf++] = '\r';break;
			case 't':buf[cnt_buf++] = '\t';break;*/
			default:buf[cnt_buf++] = temp[cnt_temp+1];
			}
			cnt_temp += 2;
		}
	}

	buf[cnt_buf] = 0;

	delete temp;

	return cnt_buf;
}

void checkEnter(char* buf, CString str)
{
	int p = 0;
	int cnt = 0;
	bool enter = false;
	for (int i=0;i<str.GetLength();i++)
	{
		if (  ((str.GetAt(i)=='\r')&&(str.GetAt(i+1)!='\n'))//can go to i+1 because of the trailing NULL
			 ||(str.GetAt(i)=='\n'))
		{
			//if (enter)
			{
				p = LINE_LENGTH - (cnt % LINE_LENGTH);
				if (p>0)
				{
					for (int sp=0;sp<p;sp++)
					{
						buf[cnt] = ' ';
						cnt++;
					}
				}
			}
			enter = true;
		}
		else if ((str.GetAt(i)=='\r')||(str.GetAt(i+1)=='\n'))
		{
			;//do nothing
		}
		else if ((str.GetAt(i) == '\\')
			   && (  (str.GetAt(i+1)=='0')
			       ||(str.GetAt(i+1)=='1')
				   ||(str.GetAt(i+1)=='2')
				   ||(str.GetAt(i+1)=='3')
				   ||(str.GetAt(i+1)=='4')
				   ||(str.GetAt(i+1)=='5')
				   ||(str.GetAt(i+1)=='6')
				   ||(str.GetAt(i+1)=='7')
				   ||(str.GetAt(i+1)=='\\')
			      )
			   )
		{
			switch (str.GetAt(i+1))
			{
			case '0':buf[cnt] = 0;break;
			case '1':buf[cnt] = 1;break;
			case '2':buf[cnt] = 2;break;
			case '3':buf[cnt] = 3;break;
			case '4':buf[cnt] = 4;break;
			case '5':buf[cnt] = 5;break;
			case '6':buf[cnt] = 6;break;
			case '7':buf[cnt] = 7;break;
			default:buf[cnt] = str.GetAt(i+1);
			}
			cnt++;
			i++;
			if ((cnt % LINE_LENGTH)==0) 
				 enter = false;
			else enter = true;
		}
		else
		{
			buf[cnt] = str.GetAt(i);
			cnt++;
			if ((cnt % LINE_LENGTH)==0) 
				 enter = false;
			else enter = true;
		}

		if (cnt>=(LINE_NO*LINE_LENGTH)) 
			i = str.GetLength()+1;
	}

	while (cnt < (LINE_NO*LINE_LENGTH))
	{
		buf[cnt] = ' ';
		cnt ++;
	}
	TRACE(CString("buf:")+buf);
}