// ListImageCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "ListImageCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define THUMWIDTH 32
#define THUMHEIGHT 32
/////////////////////////////////////////////////////////////////////////////
// CListImageCtrl

CListImageCtrl::CListImageCtrl(bool dynamic)
{
	m_bDynamic = dynamic;
}

CListImageCtrl::~CListImageCtrl()
{
	
}


BEGIN_MESSAGE_MAP(CListImageCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CListImageCtrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListImageCtrl message handlers
// This funtion is used to load the Window dropped files into the listview

void CListImageCtrl::RemoveAllMyItems()
{
	if (m_bDynamic)
	{
		int len = GetItemCount();

		for (int i=0;i<GetItemCount();i++)
		{
			char* data = (char*) GetItemData(i);
			if (data) delete data;
		}
	}
	DeleteAllItems();
}

void CListImageCtrl::Initialize()
{
	CRect rect;
	GetClientRect(&rect);

	if (m_bDynamic)
		 InsertColumn(0,_T("Splash screen"),LVCFMT_LEFT,rect.Width(),-1);
	else InsertColumn(0,_T("Splash item"),LVCFMT_LEFT,rect.Width(),-1);

	HIMAGELIST hScreens;
	if (m_bDynamic) 
		 hScreens = ImageList_Create(THUMWIDTH/2, THUMHEIGHT/2, ILC_COLOR32, 0, 1);
	else hScreens = ImageList_Create(THUMWIDTH, THUMHEIGHT, ILC_COLOR32, 0, 1);
	m_imageList.Attach(hScreens);

	SetImageList(&m_imageList, LVSIL_NORMAL);
	SetImageList(&m_imageList, LVSIL_SMALL);

	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_BRIGHTNESS));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_CONTRAST));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_TEXT));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_TIMER));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_COMMAND));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_LED));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_FONT));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_REPEAT_START));
	m_imageList.Add(AfxGetApp()->LoadIcon(IDI_ICON_SPLASH_REPEAT_STOP));

	/*Str_Brightness br;
	br.nType = SPLASH_BRIGHTNESS;
	br.nValue = 15;
	AddItem((char*)&br);*/
}

int CListImageCtrl::AddMyItem(CString text, int type)
{
	return InsertItem(GetItemCount(),text,type);
}

int CListImageCtrl::AddMyItem(char* item)
{
	CString text = GetSplashText(item);
	int cnt = InsertItem(GetItemCount(),text,((int*)item)[0]);
	if (cnt>-1)
	{
		int len = GetSplashTypeLen(((int*)item)[0]);
		char* buf = new char[len];
		memcpy(buf, item, len);
		SetItemData(cnt, (DWORD_PTR)buf);
	}
	return cnt;
}

int CListImageCtrl::InsertMyItem(int count, char* item)
{
	CString text = GetSplashText(item);
	int cnt = InsertItem(count,text,((int*)item)[0]);
	if (cnt>-1)
	{
		int len = GetSplashTypeLen(((int*)item)[0]);
		char* buf = new char[len];
		memcpy(buf, item, len);
		SetItemData(cnt, (DWORD_PTR)buf);
	}
	return cnt;
}

int CListImageCtrl::UpdateMyItemText(int count)
{
	char* data = (char*) GetItemData(count);
	if (data)
	{
		SetItemText(count, 0, GetSplashText(data));
		return count;
	}
	else return -1;
}


int CListImageCtrl::ChangeMyItemText(int count, CString text)
{
	if (SetItemText(count, 0, text))
		 return count;
	else return -1;
}

int CListImageCtrl::DeleteMyItem(int count)
{
	if (m_bDynamic)
	{
		char* data = (char*) GetItemData(count);
		if (data) delete data;
	}
	return DeleteItem(count);
}