// PopupBrightnessAutofade.cpp : implementation file
//

#include "stdafx.h"
#include "SplashEditor.h"
#include "PopupBrightnessAutofade.h"


// CPopupBrightnessAutofade dialog

IMPLEMENT_DYNAMIC(CPopupBrightnessAutofade, CDialog)

CPopupBrightnessAutofade::CPopupBrightnessAutofade(CWnd* pParent /*=NULL*/)
	: CDialog(CPopupBrightnessAutofade::IDD, pParent)
	, m_nBrightness1(0)
	, m_nBrightness2(0x14)
	, m_strBrightness1(_T(""))
	, m_strBrightness2(_T(""))
	, m_nSteps(5)
	, m_nDelay(10)
{

}

CPopupBrightnessAutofade::~CPopupBrightnessAutofade()
{
}

void CPopupBrightnessAutofade::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPLASH_SLIDER_BRIGHTNESS1, m_slider1);
	DDX_Slider(pDX, IDC_SPLASH_SLIDER_BRIGHTNESS1, m_nBrightness1);
	DDX_Control(pDX, IDC_SPLASH_SLIDER_BRIGHTNESS2, m_slider2);
	DDX_Slider(pDX, IDC_SPLASH_SLIDER_BRIGHTNESS2, m_nBrightness2);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS1, m_strBrightness1);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS2, m_strBrightness2);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS_STEPS, m_nSteps);
	DDV_MinMaxInt(pDX, m_nSteps, 1, 0x14);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS_DELAY, m_nDelay);
	DDV_MinMaxInt(pDX, m_nDelay, 1, 65535);
}


BEGIN_MESSAGE_MAP(CPopupBrightnessAutofade, CDialog)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SPLASH_SLIDER_BRIGHTNESS1, &CPopupBrightnessAutofade::OnNMReleasedcaptureSplashSliderBrightness1)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SPLASH_SLIDER_BRIGHTNESS2, &CPopupBrightnessAutofade::OnNMReleasedcaptureSplashSliderBrightness2)
END_MESSAGE_MAP()


// CPopupBrightnessAutofade message handlers

BOOL CPopupBrightnessAutofade::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_slider1.SetRange(0,0x14,TRUE);
	m_slider1.SetPos(m_nBrightness1);
	m_strBrightness1.Format(_T("%d %c"),m_nBrightness1*100/0x14,'%');

	m_slider2.SetRange(0,0x14,TRUE);
	m_slider2.SetPos(m_nBrightness1);
	m_strBrightness2.Format(_T("%d %c"),m_nBrightness2*100/0x14,'%');

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPopupBrightnessAutofade::OnNMReleasedcaptureSplashSliderBrightness1(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_strBrightness1.Format(_T("%d %c"),m_nBrightness1*100/0x14,'%');
	UpdateData(FALSE);

	*pResult = 0;
}

void CPopupBrightnessAutofade::OnNMReleasedcaptureSplashSliderBrightness2(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_strBrightness2.Format(_T("%d %c"),m_nBrightness2*100/0x14,'%');
	UpdateData(FALSE);

	*pResult = 0;
}
