// PopupCommand.cpp : implementation file
//

#include "stdafx.h"
#include "SplashEditor.h"
#include "PopupCommand.h"

// CPopupCommand dialog

IMPLEMENT_DYNAMIC(CPopupCommand, CDialog)

CPopupCommand::CPopupCommand(CWnd* pParent /*=NULL*/)
	: CDialog(CPopupCommand::IDD, pParent)
	, m_bClearDisplay(FALSE)
	, m_bReturnHome(FALSE)
	, m_bDisplayOn(FALSE)
	, m_bDisplayOff(FALSE)
	, m_bCursorOn(FALSE)
	, m_bCursorOff(FALSE)
	, m_bBlinkCursorOn(FALSE)
	, m_bBlinkCursorOff(FALSE)
	, m_bScreenShiftLeft(FALSE)
	, m_bScreenShiftRight(FALSE)
	, m_bCursorShiftLeft(FALSE)
	, m_bCursorShiftRight(FALSE)
{

}

CPopupCommand::~CPopupCommand()
{
	DestroyWindow();
}

void CPopupCommand::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_SPLASH_CHECK_CLEAR_DISPLAY, m_bClearDisplay);
	DDX_Check(pDX, IDC_SPLASH_CHECK_RETURN_HOM, m_bReturnHome);
	DDX_Check(pDX, IDC_SPLASH_CHECK_DISP_ON, m_bDisplayOn);
	DDX_Check(pDX, IDC_SPLASH_CHECK_DISP_OFF, m_bDisplayOff);
	DDX_Check(pDX, IDC_SPLASH_CHECK_CURSOR_ON, m_bCursorOn);
	DDX_Check(pDX, IDC_SPLASH_CHECK_CURSOR_OFF, m_bCursorOff);
	DDX_Check(pDX, IDC_SPLASH_CHECK_BLINK_CURSOR_ON, m_bBlinkCursorOn);
	DDX_Check(pDX, IDC_SPLASH_CHECK_BLINK_CURSOR_OFF, m_bBlinkCursorOff);
	DDX_Check(pDX, IDC_SPLASH_CHECK_SCREEN_SHIFT_LEFT, m_bScreenShiftLeft);
	DDX_Check(pDX, IDC_SPLASH_CHECK_SCREEN_SHIFT_RIGHT, m_bScreenShiftRight);
	DDX_Check(pDX, IDC_SPLASH_CHECK_CURSOR_SHIFT_LEFT, m_bCursorShiftLeft);
	DDX_Check(pDX, IDC_SPLASH_CHECK_CURSOR_SHIFT_RIGHT, m_bCursorShiftRight);
}


BEGIN_MESSAGE_MAP(CPopupCommand, CDialog)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_DISP_ON, &CPopupCommand::OnBnClickedSplashCheckDispOn)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_DISP_OFF, &CPopupCommand::OnBnClickedSplashCheckDispOff)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_CURSOR_ON, &CPopupCommand::OnBnClickedSplashCheckCursorOn)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_CURSOR_OFF, &CPopupCommand::OnBnClickedSplashCheckCursorOff)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_SCREEN_SHIFT_LEFT, &CPopupCommand::OnBnClickedSplashCheckScreenShiftLeft)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_SCREEN_SHIFT_RIGHT, &CPopupCommand::OnBnClickedSplashCheckScreenShiftRight)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_CURSOR_SHIFT_LEFT, &CPopupCommand::OnBnClickedSplashCheckCursorShiftLeft)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_CURSOR_SHIFT_RIGHT, &CPopupCommand::OnBnClickedSplashCheckCursorShiftRight)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_BLINK_CURSOR_ON, &CPopupCommand::OnBnClickedSplashCheckBlinkCursorOn)
	ON_BN_CLICKED(IDC_SPLASH_CHECK_BLINK_CURSOR_OFF, &CPopupCommand::OnBnClickedSplashCheckBlinkCursorOff)
END_MESSAGE_MAP()


void CPopupCommand::ParseCommand(Str_Command* cmd)
{
	for (int i=0;i<cmd->nLen;i++)
	{
		if ( (cmd->nValue[i] & 0xFE) == 0)
		{
			m_bClearDisplay = TRUE;
		}
		else if ( (cmd->nValue[i] & 0xFC) == 0)
		{
			m_bReturnHome = TRUE;
		}
		else if ( (cmd->nValue[i] & 0xF8) == 0)
		{//entry mode set
			
		}
		else if ( (cmd->nValue[i] & 0xF0) == 0)
		{//display or cursor on/off
			if (cmd->nValue[i] & 0x04) m_bDisplayOn = TRUE; else m_bDisplayOff = TRUE;
			if (cmd->nValue[i] & 0x02) m_bCursorOn = TRUE; else m_bCursorOff = TRUE;
			if (cmd->nValue[i] & 0x01) m_bBlinkCursorOn = TRUE; else m_bBlinkCursorOff = TRUE;
		}
		else if ( (cmd->nValue[i] & 0xE0) == 0)
		{//display or cursor shit
			if (cmd->nValue[i] & 0x08)
			{
				if (cmd->nValue[i] & 0x04) m_bScreenShiftRight = TRUE; else m_bScreenShiftLeft = TRUE;
			}
			else
			{
				if (cmd->nValue[i] & 0x04) m_bCursorShiftRight = TRUE; else m_bCursorShiftLeft = TRUE;
			}
		}
	}
}

void CPopupCommand::RetrieveCommand(Str_Command* cmd)
{
	int len = 0;

	if (m_bClearDisplay)
	{
		cmd->nTime[len]  = 0x2710;
		cmd->nValue[len] = 0x01;
		len ++;
	}

	if (m_bReturnHome)
	{
		cmd->nTime[len]  = 0x64;
		cmd->nValue[len] = 0x02;
		len ++;
	}

	if (   m_bDisplayOn || m_bDisplayOff 
		|| m_bCursorOn || m_bCursorOff
		|| m_bBlinkCursorOn || m_bBlinkCursorOff)
	{
		cmd->nTime[len]  = 0x64;
		cmd->nValue[len] = 0x08;
		if (m_bDisplayOn) cmd->nValue[len] |= 0x04;
		if (m_bCursorOn) cmd->nValue[len] |= 0x02;
		if (m_bBlinkCursorOn) cmd->nValue[len] |= 0x01;
		len ++;
	}

	if (m_bScreenShiftLeft || m_bScreenShiftRight)
	{
		cmd->nTime[len]  = 0x64;
		cmd->nValue[len] = 0x18;
		if (m_bScreenShiftRight) cmd->nValue[len] |= 0x04;
		len ++;
	}
	
	if (m_bCursorShiftLeft || m_bCursorShiftRight)
	{
		cmd->nTime[len]  = 0x64;
		cmd->nValue[len] = 0x10;
		if (m_bCursorShiftRight) cmd->nValue[len] |= 0x04;
		len ++;
	}

	cmd->nLen = len;
}


// CPopupCommand message handlers

void CPopupCommand::OnBnClickedSplashCheckDispOn()
{
	UpdateData(TRUE);
	if (m_bDisplayOn)
	{
		m_bDisplayOff = FALSE;
		if ((!m_bCursorOn) && (!m_bCursorOff)) m_bCursorOff = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckDispOff()
{
	UpdateData(TRUE);
	if (m_bDisplayOff) 
	{
		m_bDisplayOn = FALSE;
		if ((!m_bCursorOn) && (!m_bCursorOff)) m_bCursorOff = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckCursorOn()
{
	UpdateData(TRUE);
	if (m_bCursorOn)
	{
		m_bCursorOff = FALSE;
		if ((!m_bDisplayOn) && (!m_bDisplayOff)) m_bDisplayOn = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckCursorOff()
{
	UpdateData(TRUE);
	if (m_bCursorOff)
	{
		m_bCursorOn = FALSE;
		if ((!m_bDisplayOn) && (!m_bDisplayOff)) m_bDisplayOn = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckBlinkCursorOn()
{
	UpdateData(TRUE);
	if (m_bBlinkCursorOn)
	{
		m_bBlinkCursorOff = FALSE;
		if ((!m_bCursorOn) && (!m_bCursorOff)) m_bCursorOff = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckBlinkCursorOff()
{
	UpdateData(TRUE);
	if (m_bBlinkCursorOff)
	{
		m_bBlinkCursorOn = FALSE;
		if ((!m_bCursorOn) && (!m_bCursorOff)) m_bCursorOff = TRUE;
		if ((!m_bBlinkCursorOn) && (!m_bBlinkCursorOff)) m_bBlinkCursorOff = TRUE;
	}
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckScreenShiftLeft()
{
	UpdateData(TRUE);
	if (m_bScreenShiftLeft) m_bScreenShiftRight = FALSE;
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckScreenShiftRight()
{
	UpdateData(TRUE);
	if (m_bScreenShiftRight) m_bScreenShiftLeft = FALSE;
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckCursorShiftLeft()
{
	UpdateData(TRUE);
	if (m_bCursorShiftLeft) m_bCursorShiftRight = FALSE;
	UpdateData(FALSE);
}

void CPopupCommand::OnBnClickedSplashCheckCursorShiftRight()
{
	UpdateData(TRUE);
	if (m_bCursorShiftRight) m_bCursorShiftLeft = FALSE;
	UpdateData(FALSE);
}


