// PopupContrastAutofade.cpp : implementation file
//

#include "stdafx.h"
#include "SplashEditor.h"
#include "PopupContrastAutofade.h"


// CPopupContrastAutofade dialog

IMPLEMENT_DYNAMIC(CPopupContrastAutofade, CDialog)

CPopupContrastAutofade::CPopupContrastAutofade(CWnd* pParent /*=NULL*/)
	: CDialog(CPopupContrastAutofade::IDD, pParent)
	, m_nContrast1(0)
	, m_nContrast2(0xFF)
	, m_strContrast1(_T(""))
	, m_strContrast2(_T(""))
	, m_nSteps(5)
	, m_nDelay(10)
{

}

CPopupContrastAutofade::~CPopupContrastAutofade()
{
}

void CPopupContrastAutofade::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPLASH_SLIDER_CONTRAST1, m_slider1);
	DDX_Slider(pDX, IDC_SPLASH_SLIDER_CONTRAST1, m_nContrast1);
	DDX_Control(pDX, IDC_SPLASH_SLIDER_CONTRAST2, m_slider2);
	DDX_Slider(pDX, IDC_SPLASH_SLIDER_CONTRAST2, m_nContrast2);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS1, m_strContrast1);
	DDX_Text(pDX, IDC__SPLASH_EDIT_BRIGHTNESS2, m_strContrast2);
	DDX_Text(pDX, IDC__SPLASH_EDIT_CONTRAST_STEPS, m_nSteps);
	DDV_MinMaxInt(pDX, m_nSteps, 1, 256);
	DDX_Text(pDX, IDC__SPLASH_EDIT_CONTRAST_DELAY, m_nDelay);
	DDV_MinMaxInt(pDX, m_nDelay, 1, 65535);
}


BEGIN_MESSAGE_MAP(CPopupContrastAutofade, CDialog)

	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SPLASH_SLIDER_CONTRAST1, &CPopupContrastAutofade::OnNMReleasedcaptureSplashSliderContrast1)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SPLASH_SLIDER_CONTRAST2, &CPopupContrastAutofade::OnNMReleasedcaptureSplashSliderContrast2)
END_MESSAGE_MAP()


// CPopupContrastAutofade message handlers



BOOL CPopupContrastAutofade::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_slider1.SetRange(0,0xFF, TRUE);
	m_slider1.SetPos(m_nContrast1);
	m_strContrast1.Format(_T("%d %c"),m_nContrast1*100/0xFF,'%');

	m_slider2.SetRange(0,0xFF, TRUE);
	m_slider2.SetPos(m_nContrast2);
	m_strContrast2.Format(_T("%d %c"),m_nContrast2*100/0xFF,'%');

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPopupContrastAutofade::OnNMReleasedcaptureSplashSliderContrast1(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_strContrast1.Format(_T("%d %c"),m_nContrast1*100/0xFF,'%');
	UpdateData(FALSE);

	*pResult = 0;
}

void CPopupContrastAutofade::OnNMReleasedcaptureSplashSliderContrast2(NMHDR *pNMHDR, LRESULT *pResult)
{
	UpdateData(TRUE);
	m_strContrast2.Format(_T("%d %c"),m_nContrast2*100/0xFF,'%');
	UpdateData(FALSE);

	*pResult = 0;
}
