// PopupLedAutoscroll.cpp : implementation file
//

#include "stdafx.h"
#include "SplashEditor.h"
#include "PopupLedAutoscroll.h"


// CPopupLedAutoscroll dialog

IMPLEMENT_DYNAMIC(CPopupLedAutoscroll, CDialog)

CPopupLedAutoscroll::CPopupLedAutoscroll(CWnd* pParent /*=NULL*/)
	: CDialog(CPopupLedAutoscroll::IDD, pParent)
	, m_bScrollLeft(FALSE)
	, m_bScrollRight(TRUE)
	, m_nScrollDelay(3)
	, m_nScrollTimes(8)
{
	for (int i=0;i<8;i++) m_bLed[i] = FALSE;
}

CPopupLedAutoscroll::~CPopupLedAutoscroll()
{
}

void CPopupLedAutoscroll::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED1, m_bLed[0]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED2, m_bLed[1]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED3, m_bLed[2]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED4, m_bLed[3]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED5, m_bLed[4]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED6, m_bLed[5]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED7, m_bLed[6]);
	DDX_Check(pDX, IDC_SPLASH_CHECK_LED8, m_bLed[7]);
	DDX_Check(pDX, IDC_SPLASH_LED_SCROLL_LEFT, m_bScrollLeft);
	DDX_Check(pDX, IDC_SPLASH_LED_SCROLL_RIGHT, m_bScrollRight);
	DDX_Text(pDX, IDC_SPLASH_EDIT_SCROLLTEXT_DELAY, m_nScrollDelay);
	DDV_MinMaxUInt(pDX, m_nScrollDelay, 1, 1000);
	DDX_Text(pDX, IDC_SPLASH_EDIT_SCROLLLED, m_nScrollTimes);
	DDV_MinMaxUInt(pDX, m_nScrollTimes, 1, 8);
}


BEGIN_MESSAGE_MAP(CPopupLedAutoscroll, CDialog)
	ON_BN_CLICKED(IDC_SPLASH_LED_SCROLL_LEFT, &CPopupLedAutoscroll::OnBnClickedSplashLedScrollLeft)
	ON_BN_CLICKED(IDC_SPLASH_LED_SCROLL_RIGHT, &CPopupLedAutoscroll::OnBnClickedSplashLedScrollRight)
END_MESSAGE_MAP()


// CPopupLedAutoscroll message handlers
void CPopupLedAutoscroll::RetrieveLed(Str_Led* cmd, int step)
{
	if (GetSafeHwnd()) UpdateData(TRUE);
	
	unsigned char led = 0;

	for (int i=0;i<8;i++)
		if (m_bLed[i] != 0) led |= (1<<i);

	if (m_bScrollLeft)
	{
		//for (int i=0;i<step;i++)
		{
			BOOL temp = m_bLed[0];
			for (int k=1;k<8;k++)
				m_bLed[k-1] = m_bLed[k];
			m_bLed[7] = temp;
		}
	}
	else
	{
		//for (int i=0;i<step;i++)
		{
			BOOL temp = m_bLed[7];
			for (int k=7;k>0;k--)
				m_bLed[k] = m_bLed[k-1];
			m_bLed[0] = temp;
		}
	}

	cmd->nValue = led;
}

void CPopupLedAutoscroll::OnBnClickedSplashLedScrollLeft()
{
	UpdateData(TRUE);
	m_bScrollLeft = TRUE;
	m_bScrollRight = FALSE;
	UpdateData(FALSE);
}

void CPopupLedAutoscroll::OnBnClickedSplashLedScrollRight()
{
	UpdateData(TRUE);
	m_bScrollLeft = FALSE;
	m_bScrollRight = TRUE;
	UpdateData(FALSE);
}
