#pragma once

#include "Resource.h"
//#include "afxwin.h"
#include "ListImageCtrl.h"
#include "afxwin.h"
#include "afxcmn.h"

// CSplashDialog dialog

class CSplashDialog : public CDialog
{
	DECLARE_DYNAMIC(CSplashDialog)

public:
	CSplashDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CSplashDialog();

// Dialog Data
	enum { IDD = IDD_DIALOG_SPLASH };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	bool ReadOneSplashItem(char* buf, int insert_type);

	bool ParseSplashBuffer(unsigned char* data, int& lines);
	bool BuildSplashBuffer(unsigned char* data, int& real_len, int& comp_len);

	int m_nAddrCounter;
	int m_nHCounter;//H file counter
	void writeHFile(FILE* file, CString text, const unsigned char* data);
	
	bool CheckNestedCycles();//return's true if ok
	void MoveUp(bool button);
	void MoveDown(bool button);

	int GetSplashMaxSize();
	int GetSplashSize();

	void AddAutomaticItem(char* item, int insert_type, int& row_pos);

	DECLARE_MESSAGE_MAP()
public:
	CListImageCtrl m_listSplash;
	virtual BOOL OnInitDialog();
	virtual BOOL DestroyWindow();
	afx_msg void OnBnClickedButtonDownload();
	CStatic m_sAction;
	CProgressCtrl m_pBar;
	afx_msg void OnBnClickedButtonUpload();
	afx_msg void OnBnClickedButtonAppend();
	afx_msg void OnBnClickedButtonDelete();
	afx_msg void OnBnClickedButtonInsertAfter();
	afx_msg void OnBnClickedButtonInsertBefore();
	afx_msg void OnNMDblclkListSplash(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedSplashButtonMoveUp();
	afx_msg void OnBnClickedSplashButtonMoveDown();
	afx_msg void OnBnClickedSplashButtonAddRepeat();
	afx_msg void OnBnClickedSplashButtonTest();
	afx_msg void OnBnClickedSplashButtonClean();
	BOOL m_bGenerateHFile;
	afx_msg void OnBnClickedSplashButtonImport();
};
