// SplashSelector.cpp : implementation file
//

#include "stdafx.h"
#include "SplashEditor.h"
#include "SplashSelector.h"


// CSplashSelector dialog

IMPLEMENT_DYNAMIC(CSplashSelector, CDialog)

CSplashSelector::CSplashSelector(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashSelector::IDD, pParent),
	m_listSplash(false)
{
	m_nSelectedType = -1;
}

CSplashSelector::~CSplashSelector()
{
}

void CSplashSelector::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_SPLASH, m_listSplash);
}


BEGIN_MESSAGE_MAP(CSplashSelector, CDialog)
	ON_BN_CLICKED(IDOK, &CSplashSelector::OnBnClickedOk)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_SPLASH, &CSplashSelector::OnNMDblclkListSplash)
END_MESSAGE_MAP()


// CSplashSelector message handlers

BOOL CSplashSelector::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_listSplash.Initialize();
	m_listSplash.AddMyItem(_T("Brightness"), SPLASH_BRIGHTNESS);
	m_listSplash.AddMyItem(_T("Contrast"), SPLASH_CONTRAST);
	m_listSplash.AddMyItem(_T("Text"), SPLASH_TEXT);
	m_listSplash.AddMyItem(_T("Timer"), SPLASH_TIMER);
	m_listSplash.AddMyItem(_T("Command"), SPLASH_COMMAND);
	m_listSplash.AddMyItem(_T("LED"), SPLASH_LED);
	m_listSplash.AddMyItem(_T("Font"), SPLASH_FONT);

	m_listSplash.AddMyItem(_T("Brightness (autofade)"), SPLASH_BRIGHTNESS);
	m_listSplash.AddMyItem(_T("Contrast (autofade)"), SPLASH_CONTRAST);
	m_listSplash.AddMyItem(_T("Text (autoscroll)"), SPLASH_TEXT);
	m_listSplash.AddMyItem(_T("LED (autoscroll)"), SPLASH_LED);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSplashSelector::OnBnClickedOk()
{
	//m_nSelectedType = m_listSplash.GetSelectionMark();
	switch (m_listSplash.GetSelectionMark())
	{
	case 0:  m_nSelectedType = SPLASH_BRIGHTNESS;break;
	case 1:  m_nSelectedType = SPLASH_CONTRAST;break;
	case 2:  m_nSelectedType = SPLASH_TEXT;break;
	case 3:  m_nSelectedType = SPLASH_TIMER;break;
	case 4:  m_nSelectedType = SPLASH_COMMAND;break;
	case 5:  m_nSelectedType = SPLASH_LED;break;
	case 6:  m_nSelectedType = SPLASH_FONT;break;
	case 7:  m_nSelectedType = SPLASH_BRIGHTNESS_AUTOFADING;break;
	case 8:  m_nSelectedType = SPLASH_CONTRAST_AUTOFADING;break;
	case 9:  m_nSelectedType = SPLASH_TEXT_AUTOSCROLL;break;
	case 10: m_nSelectedType = SPLASH_LED_AUTOSCROLL;break;
	}
	OnOK();
}

void CSplashSelector::OnNMDblclkListSplash(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnBnClickedOk();
	*pResult = 0;
}
