/**
 * PicoLCD 4x20 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#ifndef __H_LOCK_H__
#define __H_LOCK_H__

#ifndef _WIN32

#include <pthread.h>
typedef pthread_mutex_t CRITICAL_SECTION;
#endif

class HLock
{
public:
	HLock();
	virtual ~HLock();
	bool lock( void );
	void unlock( void );
	void destroy( void );

private:
	CRITICAL_SECTION m_mutex;
#ifndef _WIN32
	bool m_bUnderDestroy;
#endif
};

#endif //__H_LOCK_H__
